/**
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2010 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

package org.ow2.orchestra.designer.bpmn.views.process {
import org.ow2.orchestra.designer.bpmn.views.*;

import flash.events.Event;

import mx.events.ResizeEvent;

import org.ow2.orchestra.designer.bpmn.model.process.ProcessModel;

/**
 *
 * @author hallouin-s
 */
public class ProcessView extends AbstractDiagramView {

  /**
   *
   * @param processModel
   */
  public function ProcessView(processModel:ProcessModel) {
    super(processModel);
    var poolView:ProcessPoolView = new ProcessPoolView(processModel);
    poolView.percentHeight = 100;
    this.addChild(poolView);
    this.addEventListener(ResizeEvent.RESIZE, function(event:Event):void {
      poolView.percentHeight = 100;
    });
  }

  /**
   *
   * @return
   */
  public function get processModel():ProcessModel {
    return ProcessModel(this.flowModel);
  }
}
}
