/**
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2010 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.bpmn.views.process {
import flash.events.Event;

import mx.binding.utils.ChangeWatcher;
import mx.containers.HBox;
import mx.controls.Label;
import mx.events.ResizeEvent;

import org.ow2.orchestra.designer.bpmn.model.process.SequenceFlowModel;
import org.ow2.orchestra.designer.bpmn.views.*;

public class SequenceFlowView extends FlowView {
  private var conditionLabel:Label;
  private var conditionBox:HBox;

  function SequenceFlowView(flowModel:SequenceFlowModel, flowView:AbstractDiagramView) {
    super(flowModel, flowView);
    watchers.addItem(ChangeWatcher.watch(_flowModel, "condition", redraw));
    watchers.addItem(ChangeWatcher.watch(_flowModel, "isDefault", redraw));

    conditionLabel = new Label();
    conditionBox = new HBox();
    conditionBox.setStyle("backgroundColor", "#000000");
    conditionBox.setStyle("color", "#ffffff");
    conditionBox.setStyle("cornerRadius", "10");
    conditionBox.setStyle("borderStyle", "solid");
    conditionBox.addChild(conditionLabel);
    conditionBox.addEventListener(ResizeEvent.RESIZE, setConditionBoxPosition);

  }

  public override function redraw(event:Event = null, retries:int = 10):void {
    style.isConditional = this.sequenceFlowModel.condition != null && this.sequenceFlowModel.condition != "";
    style.isDefault = this.sequenceFlowModel.isDefault;

    super.redraw(event, retries);

    // draw condition
    if (style.isConditional) {
      conditionLabel.text = this.sequenceFlowModel.condition;
      conditionBox.setVisible(true);
      setConditionBoxPosition();
      canvas.addChild(conditionBox);
    }

  }

  private function setConditionBoxPosition(event:Event = null):void {
    conditionBox.x = (_sourcePoint.x + _targetPoint.x - conditionBox.width) / 2;
    conditionBox.y = (_sourcePoint.y + _targetPoint.y - conditionBox.height) / 2;
  }

  private function get sequenceFlowModel():SequenceFlowModel {
    return SequenceFlowModel(super.model);
  }

}
}
